REM http://delta.affinix.com/download/qca/2.0/qca-2.1.0.tar.gz

set OSGEO4W_ROOT=C:\OSGeo4W64
set P=qca
set V=2.1.0
set B=1

set R=..\..\..\x86_64\release\qt4\%P%
for %%i in (devel libs) do (
	if not exist %R%\%P%-%%i mkdir %R%\%P%-%%i
	copy %%i.hint %R%\%P%-%%i\setup.hint
	copy ..\COPYING %R%\%P%-%%i\%P%-%%i-%V%-%B%.txt
)

set pf=%ProgramFiles(x86)%
if "%pf%"=="" set pf=%ProgramFiles%
path %SYSTEMROOT%\system32;%SYSTEMROOT%;%SYSTEMROOT%\System32\Wbem;%pf%\CMake\bin
call "%pf%\Microsoft Visual Studio 10.0\VC\vcvarsall.bat" x64
path %pf%\Microsoft Visual Studio 10.0\Common7\IDE;%PATH%
set OLDPATH=%PATH%
call "%OSGEO4W_ROOT%\bin\o4w_env.bat"
path %OLDPATH%;%OSGEO4W_ROOT%\bin;c:\cygwin\bin
echo on

set BUILDDIR=build64
if not exist %BUILDDIR% mkdir %BUILDDIR%

cd %BUILDDIR%

set LIB=%LIB%;%OSGEO4W_ROOT%\lib
set INCLUDE=%INCLUDE%;%OSGEO4W_ROOT%\include

set BUILDCONF=RelWithDebInfo

cmake -G "Visual Studio 10 Win64" ^
	-DCMAKE_CONFIGURATION_TYPES=%BUILDCONF% ^
	-DQCA_PLUGINS_INSTALL_DIR=%OSGEO4W_ROOT%/apps/qt4/plugins/ ^
	-DQCA_BINARY_INSTALL_DIR=%OSGEO4W_ROOT%/bin ^
	-DQCA_LIBRARY_INSTALL_DIR=%OSGEO4W_ROOT%/lib ^
	-DQCA_FEATURE_INSTALL_DIR=%OSGEO4W_ROOT%/apps/qt4/mkspecs/features/ ^
	-DQCA_INCLUDE_INSTALL_DIR=%OSGEO4W_ROOT%/include/qt4 ^
	-DQCA_PRIVATE_INCLUDE_INSTALL_DIR=%OSGEO4W_ROOT%/include/qt4 ^
	-DQCA_DOC_INSTALL_DIR=%OSGEO4W_ROOT%/apps/qt4/doc/html/qca ^
	-DQCA_MAN_INSTALL_DIR=%OSGEO4W_ROOT%/apps/qt4/man/ ^
	-DPKGCONFIG_INSTALL_PREFIX=%OSGEO4W_ROOT%/lib/pkgconfig ^
        ..\..
if errorlevel 1 goto error

for %%i in (ZERO_CHECK ALL_BUILD INSTALL) do (
	echo %%i: %DATE% %TIME%
	devenv %P%.sln /Project %%i /Build %BUILDCONF%
	if errorlevel 1 (echo %%i error & goto error)
)

cd ..

tar -C %OSGEO4W_ROOT% -cvjf %R%\%P%-devel\%P%-devel-%V%-%B%.tar.bz2 ^
	include/qt4/QtCrypto ^
	bin/qca.pdb ^
	lib/qca.lib ^
	bin/mozcerts.pdb ^
	bin/qcatool.pdb ^
	apps/Qt4/mkspecs/features/crypto.prf ^
	lib/cmake/Qca/ ^
	apps/Qt4/plugins/crypto/qca-gnupg.pdb ^
	apps/Qt4/plugins/crypto/qca-logger.pdb ^
	apps/Qt4/plugins/crypto/qca-ossl.pdb ^
	apps/Qt4/plugins/crypto/qca-softstore.pdb
if errorlevel 1 goto error

tar -C %OSGEO4W_ROOT% -cvjf %R%\%P%-libs\%P%-libs-%V%-%B%.tar.bz2 ^
	apps/Qt4/certs/rootcerts.pem ^
	bin/qca.dll ^
	bin/mozcerts.exe ^
	bin/qcatool.exe ^
	apps/Qt4/plugins/crypto/qca-gnupg.dll ^
	apps/Qt4/plugins/crypto/qca-logger.dll ^
	apps/Qt4/plugins/crypto/qca-ossl.dll ^
	apps/Qt4/plugins/crypto/qca-softstore.dll
if errorlevel 1 goto error

tar -C .. -cvjf %R%\%P%-libs\%P%-libs-%V%-%B%-src.tar.bz2 ^
	osgeo4w/package64.cmd ^
	osgeo4w/libs.hint ^
	osgeo4w/devel.hint
if errorlevel 1 goto error

:error
